package  
{
	import flash.display.Sprite;
	import flash.display.StageScaleMode
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 400, height = 320)]
	public class Demo extends Sprite
	{
		private var unitX:Number = 40, unitY:Number = 40;
		private var a1:Arrow, a2:Arrow, b1:Arrow, b2:Arrow;
		private var box:DottedBox, m:Matrix;
		private var grid2:Sprite;
		
		public function Demo() 
		{
			stage.scaleMode = StageScaleMode.NO_SCALE
			drawGrid(this, 40, 40, 2, 0x0000FF, 0.1);
			
			m = new Matrix();	//identity matrix
			m.translate(stage.stageWidth * 0.5, stage.stageHeight * 0.5)
			box = new DottedBox(); addChild(box);
			box.transform.matrix = m;
			
			grid2 = new Sprite(); addChild(grid2);
			grid2.transform.matrix = m;
			drawGrid(grid2, 40, 40, 1, 0xFF0000, 0.3, -stage.stageWidth*0.5, -stage.stageHeight*0.5,false);
			
			a1 = new Arrow(unitX, 10, 0x0000FF); addChild(a1);
			a1.x = stage.stageWidth * 0.5; a1.y = stage.stageHeight * 0.5;
			a2 = new Arrow(unitY, 10, 0x0000FF); addChild(a2);
			a2.x = stage.stageWidth * 0.5; a2.y = stage.stageHeight * 0.5; a2.rotation = 90
			
			b1 = new Arrow(unitX, 10, 0xFF0000); addChild(b1); b1.name = "b1";
			b1.x = stage.stageWidth * 0.5; b1.y = stage.stageHeight * 0.5;
			b2 = new Arrow(unitY, 10, 0xFF0000); addChild(b2); b2.name = "b2";
			b2.x = stage.stageWidth * 0.5; b2.y = stage.stageHeight * 0.5; b2.rotation = 90
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, start);
			stage.addEventListener(MouseEvent.MOUSE_UP, stop);
		}
		
		private function start(e:MouseEvent):void 
		{
			if (e.target.name == "b1") b1.addEventListener(Event.ENTER_FRAME, refresh);
			else if(e.target.name == "b2") b2.addEventListener(Event.ENTER_FRAME, refresh);
		}
		
		private function stop(e:MouseEvent):void 
		{
			e.target.removeEventListener(Event.ENTER_FRAME, refresh);
		}
		
		private function refresh(e:Event):void 
		{
			var v:Vector2D = new Vector2D(mouseX - stage.stageWidth * 0.5, mouseY - stage.stageHeight * 0.5);
			e.currentTarget.w = v.getMagnitude()+2;
			e.currentTarget.rotation = Math2.degreeOf(v.getAngle());
			
			if (e.currentTarget.name == "b1") {
				m.a = v.projectionOn(new Vector2D(40,0))/unitX; 
				m.b = v.projectionOn(new Vector2D(0,40))/unitY;
			}
			else if (e.currentTarget.name == "b2") {
				m.c = v.projectionOn(new Vector2D(40,0))/unitX;
				m.d = v.projectionOn(new Vector2D(0,40))/unitY;
			}
			box.transform.matrix = m;
			grid2.transform.matrix = m;
		}
		
		private function drawGrid(container:Sprite, separationX:Number, separationY:Number, gridThickness:Number, gridCol:Number, alp:Number, shiftX:Number = 0, shiftY:Number = 0, showDot:Boolean = true ):void
		{
			if(showDot){
				var center:Circle = new Circle(gridCol,5); container.addChild(center);
				center.x = stage.stageWidth * 0.5; center.y = stage.stageHeight * 0.5; 
			}
			container.graphics.clear();
			container.graphics.lineStyle(gridThickness, gridCol, alp);
			//draw the x and y grids
			for (var i:int = 0; i < stage.stageHeight; i += separationX) {
				container.graphics.moveTo(0+shiftX, i+shiftY); 
				container.graphics.lineTo(stage.stageWidth+shiftX, i+shiftY)
			}
			for (var j:int = 0; j < stage.stageWidth; j += separationY) {
				container.graphics.moveTo(j+shiftX, 0+shiftY); 
				container.graphics.lineTo(j+shiftX, stage.stageHeight+shiftY)
			}
			
		}
	}

}