package  
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 400, height = 300)]
	public class FakeIso extends Sprite
	{
		private var f1:Fish, m:Matrix;
		private var disp:Point;
		private var axisX:Point, axisY:Point;
		
		public function FakeIso() {
			disp = new Point(stage.stageWidth * 0.5, stage.stageHeight * 0.5);
			m = new Matrix();
			m.tx = disp.x; m.ty = disp.y;		//displace to the center of stage
			f1 = new Fish(); addChild(f1);		
			f1.transform.matrix = m;			//apply transformation to onto fish
			
			axisX = new Point(1, 0);				//vector for x - axis
			axisY = new Point(0, 1);				//vector for y -axis
			stage.addEventListener(MouseEvent.MOUSE_DOWN, start);	//start interaction
			stage.addEventListener(MouseEvent.MOUSE_UP, end);			//end interaction
		}
		
		private function start(e:MouseEvent):void {
			f1.addEventListener(Event.ENTER_FRAME, update);
		}
		
		private function end(e:MouseEvent):void {
			f1.removeEventListener(Event.ENTER_FRAME, update);
		}
		
		private function update(e:Event):void {
			axisX.setTo(mouseX - f1.x, mouseY - f1.y);	//determine orientation (but magnitude changed as well)
			axisX.normalize(1);											//fix magnitude of vector with new orientation to 1 unit
			apply2Matrix();		//apply matrix onto fish
		}
		
		private function apply2Matrix ():void {
			m.setTo(axisX.x, axisX.y, axisY.x, axisY.y, disp.x, disp.y);
			f1.transform.matrix = m;
		}
	}

}