package  
{
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 400, height = 400)]
	public class FakeIso2 extends Sprite
	{
		private var f1:Fish, m:Matrix;
		private var disp:Point;
		private var velo:Point, axisY:Point;
		private var delta_positive:Matrix, delta_negative:Matrix, jumpStart:Boolean = true;
		
		public function FakeIso2() {
			stage.scaleMode = StageScaleMode.NO_SCALE
			disp = new Point(stage.stageWidth * 0.5, stage.stageHeight * 0.5);
			velo = new Point(1, 0); 		//velo will be used to define x-axis
			axisY = new Point(0, 1);
			delta_positive = new Matrix(); delta_positive.rotate(Math.PI * 0.01);		//positive rotation
			delta_negative = new Matrix(); delta_negative.rotate(Math.PI * -0.01);	//negative rotation
			
			m = new Matrix();
			m.tx = disp.x; m.ty = disp.y;
			f1 = new Fish(); addChild(f1);
			f1.transform.matrix = m;
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyUp);
		}
		
		private function update(e:Event):void {
			var front_side:Boolean = velo.x > 0				//checking for the front side of fish
			if (front_side) { f1.colorBody(0x002233,0.5) }	//color the front side of fish
			else f1.colorBody(0xFFFFFF,0.5)						//white applied to back side of fish
			
			disp = disp.add(velo);							//update current displacement with velocity
			var velo_norm:Point = velo.clone();	//in case velo > 0, we need to recalculate 1 unit of length for x.
			velo_norm.normalize(1);						//note that x-axis more than 1 will perform scaling. We dont want that for now
			m.setTo(velo_norm.x, velo_norm.y, axisY.x, axisY.y, disp.x, disp.y);
			f1.transform.matrix = m;
		}
		
		private function keyUp(e:KeyboardEvent):void {
			if (jumpStart) {
				stage.addEventListener(Event.ENTER_FRAME, update);
				jumpStart = false;
			}
			if (e.keyCode == Keyboard.LEFT) {
				velo = delta_negative.transformPoint(velo)	//rotate velo counter-clockwise
			}
			else if (e.keyCode == Keyboard.RIGHT) {
				velo = delta_positive.transformPoint(velo)	//rotate velo clockwise
			}
		}
	}

}