package  
{
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 400, height = 400)]
	public class FakeIso3 extends Sprite
	{
		private var f1:Fish, m:Matrix;
		private var disp:Point;
		private var velo:Point, axisY:Point;
		private var delta_positive:Matrix, delta_negative:Matrix, jumpStart:Boolean = true;
		
		public function FakeIso3() {
			stage.scaleMode = StageScaleMode.NO_SCALE
			disp = new Point(stage.stageWidth * 0.5, stage.stageHeight * 0.5);
			velo = new Point(1, 0); axisY = new Point(0, 1);
			delta_positive = new Matrix(); delta_positive.rotate(Math.PI * 0.03);
			delta_negative = new Matrix(); delta_negative.rotate(Math.PI * -0.03);
			
			m = new Matrix();
			m.tx = disp.x; m.ty = disp.y;
			f1 = new Fish(); addChild(f1);
			f1.transform.matrix = m;
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDown);
		}
		
		private function update(e:Event):void {
			var front_side:Boolean = velo.x * axisY.y > 0
			if (front_side) { f1.colorBody(0x002233,0.5) }
			else f1.colorBody(0xFFFFFF,0.5)
			
			disp = disp.add(velo);
			var velo_norm:Point = velo.clone();
			velo_norm.normalize(1);
			m.setTo(velo_norm.x, velo_norm.y, axisY.x, axisY.y, disp.x, disp.y);
			f1.transform.matrix = m;
		}
		
		private function keyDown(e:KeyboardEvent):void {
			if (jumpStart) {
				stage.addEventListener(Event.ENTER_FRAME, update);
				jumpStart = false;
			}
			if (e.keyCode == Keyboard.LEFT) {
				velo = delta_negative.transformPoint(velo)
			}
			else if (e.keyCode == Keyboard.RIGHT) {
				velo = delta_positive.transformPoint(velo)
			}
			if (e.keyCode == Keyboard.UP) {
				axisY = delta_negative.transformPoint(axisY)
			}
			else if (e.keyCode == Keyboard.DOWN) {
				axisY = delta_positive.transformPoint(axisY)
			}
		}
	}

}